#!/usr/bin/bash

COUNT_LIMIT=5
TIME_LIMIT=2
MQUEUE_LIMIT=10

(
flock -x -n 300 || exit 0

if [ -f /tmp/c2padmin_crash ] || [ -f /tmp/c2padmin_restart ]; then
	if [ `find /var/cache/c2padmin/wd_cnt -mmin -$TIME_LIMIT` ]; then
		COUNTER=`cat /var/cache/c2padmin/wd_cnt 2> /dev/null`

		if [[ $? -ne 0 ]]; then
			COUNTER=0;
		else
			COUNTER=`echo -n $COUNTER`
		fi;
	else
		COUNTER=0;
	fi;

	if [[ ! $COUNTER =~ ^[0-9]+$ ]]; then
		echo -n 1 > /var/cache/c2padmin/wd_cnt;
	else
		if [ $COUNTER -ge $COUNT_LIMIT ]; then
			rm -f /tmp/c2padmin_crash
			rm -f /tmp/c2padmin_restart;
			echo -n 1 > /var/cache/c2padmin/wd_cnt;
		else
			COUNTER=$((COUNTER + 1));
			echo -n $COUNTER > /var/cache/c2padmin/wd_cnt;
		fi;
	fi;
else
	echo -n 1 > /var/cache/c2padmin/wd_cnt;
fi;

if [ -f /tmp/c2padmin_crash ]; then
	/usr/bin/systemctl restart c2padmin.service && rm -f /tmp/c2padmin_crash;
	
fi

if [ -f /tmp/c2padmin_restart ]; then
	sleep 1;
	/usr/bin/systemctl restart c2padmin.service && rm -f /tmp/c2padmin_restart;
fi

MQUEUE=`mailq | grep -c "^[A-F0-9]"`

if [ $MQUEUE -lt $MQUEUE_LIMIT ]; then
	find /tmp/ -name "c2padmin-*.dump" -type f | xargs -I{} sh -c "echo 'Crash dump '`date '+%Y-%m-%dT%H:%M:%S%z'`|mail -s 'C2Padmin crash '`date '+%Y-%m-%dT%H:%M:%S%z'` -a {} admin@hosting90.cz"
	find /tmp/ -name "c2padmin-*.dump" -type f | xargs -I{} mv {} {}.send
fi;


) 300> /var/lock/c2padmin_wd.lock