#!/usr/bin/env python

from distutils.core import setup,Extension

mod_dioutil = Extension('dioutilc',
                    sources = ['src/dioutil/dioutilmodule.c'])

setup(name='c2padmin',
	version='0.1',
	description='Cloud To Private Virtualization admin utils',
	author='Cloud To Private',
	author_email='admin@cloudtoprivate.cz',
	url='https://www.cloudtoprivate.cz',
	packages=['dioutil','c2padmin','c2padmin.virt','c2padmin.backups'],
	package_dir={
		'dioutil':'src/dioutil',
		'c2padmin':'src/c2padmin',
		'c2padmin.virt':'src/c2padmin/virt',
		'c2padmin.backups':'src/c2padmin/backups',
	},
	package_data={
		'c2padmin.virt':['virtual-template.xml'],
		'c2padmin.backups':['conf/backup_defaults.ini'],
		'c2padmin':['conf/defaults.ini']
		},
	data_files=[
		('/usr/bin',['c2padmin']),
		('/usr/lib/systemd/system',['systemd/c2padmin.service']),
		('/etc/libvirt/hooks',['hooks/qemu']),
		('/etc/c2padmin', ['misc/watchdog.sh']),
		('/etc/c2padmin/cert', []),
		('/etc/c2padmin/backups', []),
		('/etc/cron.d', ['misc/c2padmin_wd'])
		],
	ext_modules = [mod_dioutil],
	options = {'bdist_rpm':{
		'install_script':'build/rpm-install-script.sh',
		'post_install':'build/c2padmin-postinstall.sh',
		'pre_uninstall':'build/c2padmin-preuninstall.sh',
		'requires':'python-lzo >= 1.0 rfoo >= 1.3.0_ssl_0 pyOpenSSL python-crypto openvpn nagios-plugins-all c2pmonitoring linux-eoip dhcp',
	}}
	)
