#!/usr/bin/python
# -*- coding: utf-8 -*-

import socket_rpc, logging, subprocess, time, sys, traceback, config
from logger import logger_root

class Diagnostics(socket_rpc.Socket_RPC):
	def __init__(self, port):
		super(Diagnostics, self).__init__('0.0.0.0', port, 30, 10)
		
		self.bind_login(self.login)
		self.bind(self.log_level)
		self.serve_forever()
	
	def __del__(self):
		self.close()	
		
	def login(self, password):
		if(password == 'Drmfslsd'):
			return True
			
		return False
		
	def log_level(self, log_level):
		'''
		Change loging level:
		{"func": "log_level", "args": "<log_level>"}
		.
		'''
		
		log_levels = ['CRITICAL', 'ERROR', 'WARNING', 'INFO', 'DEBUG']
		log_level = log_level.upper()
		if(log_level not in log_levels):
			return [False, 'bad loglevel']
		
		else:
			logger_root.setLevel(log_level)
			return [True, 'log level isset']
		
	def _greeting(self):
		return 'C2Padmin CLI\r\n'
		
	def make_dump(self, path = None):
		tb = Extend_traceback()
		exc = tb.exc_info()
		if(exc[1] != None):
			exc_str = 'EXCEPTION:\n----------\n\n' + exc[1].__class__.__name__ + '(\'' + str(exc[1]) + '\')\n\n'
			
		else:
			exc_str = ''
		dump = exc_str
		dump += 'BACKTRACE:\n'
		dump += '----------\n\n'
		dump += ''.join(traceback.format_tb(exc[2])) + '\n'
		
		dump += 'NODE_CONFIG:\n'
		dump += '------------\n\n'
		dump += str(config.node_config) + '\n\n'
		
		dump += 'NODE_STATUS:\n'
		dump += '------------\n\n'
		dump += str(config.node_status) + '\n\n'
		
		dump += 'JOURNAL:\n'
		dump += '--------\n\n'
		try:
			journal = subprocess.check_output(['/usr/bin/journalctl', '-u', 'c2padmin', '--since', time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(time.time() - 600))])
			dump += journal
			
		except:
			dump += '  --- Unable to get journal ---\n\n'
			
		return dump

class Extend_traceback(object):
	class TB(object):
		def __init__(self, tb_frame, tb_lineno, tb_next):
			self.tb_frame = tb_frame
			self.tb_lineno = tb_lineno
			self.tb_next = tb_next

	def _current_stack(self, skip=0):
		try: 
			1/0
			
		except ZeroDivisionError:
			f = sys.exc_info()[2].tb_frame
			
		for i in xrange(skip + 2):
			f = f.f_back
		
		tb = []
		while f is not None:
			tb.append((f, f.f_lineno))
			f = f.f_back
	
		return tb

	def _extend_traceback(self, tb, stack):
		head = tb
		for tb_frame, tb_lineno in stack:
			head = self.TB(tb_frame, tb_lineno, head)
		
		return head

	def exc_info(self):
		t, v, tb = sys.exc_info()
		full_tb = self._extend_traceback(tb, self._current_stack(3))
		return t, v, full_tb		
		
		