import socket,select
import struct
import config

class McastServer():
	"""UDP multicast listener"""
	def __init__(self):
		self.sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM, socket.IPPROTO_UDP)
		self.sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
		
	def bind(self):
		self.sock.bind((config.config.get('network','multicast_group'), config.config.get('network', 'multicast_port',int))) 
		
		mreq = struct.pack("4sl", socket.inet_aton(config.config.get('network','multicast_group')), socket.INADDR_ANY)

		self.sock.setsockopt(socket.IPPROTO_IP, socket.IP_ADD_MEMBERSHIP, mreq)
	
	def recv(self,size,timeout=None):
		rlist,dummy,dummy = select.select([self.sock],[],[],timeout)
		if len(rlist) == 0:
			return None
		else:
  			return self.sock.recv(size)

class McastClient():
	"""UDP multicast sender"""
	def __init__(self):
		self.sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM, socket.IPPROTO_UDP)
		self.sock.setsockopt(socket.IPPROTO_IP, socket.IP_MULTICAST_TTL, 2)
		pass
	
	def send(self,data):
		"""docstring for send"""
		self.sock.sendto(data, (config.config.get('network','multicast_group'), config.config.get('network', 'multicast_port',int)))
	
	def close(self):
		self.sock.close()