import libvirt,os,urllib2,re,json,traceback

import volume

from xml.dom.minidom import parseString
from xml.dom.minidom import parse

from c2padmin import cache

import time, string, subprocess, socket, threading, select
from c2padmin import network
import dioutil

from c2padmin import logger as logmodule

import xmlrpclib
import c2padmin

logger = logmodule.getLogger(__name__)

class TRANSFERRED_BYTES(object):
	"""docstring for TRANSFERRED_BYTES"""
	# pomocni trida pro clone_server a migrate_server
	# vytvori transportni objekt pro predavani informace o jiz prenesenem objemu dat
	
	def __init__(self):
		self._transferred_bytes = 0
	def __str__(self):
		return str(self._transferred_bytes)
	def __int__(self):
		return int(self._transferred_bytes)
	def __add__(self, other):
		return self._transferred_bytes + other
	def __radd__(self, other):
		return other + self._transferred_bytes
	def __iadd__(self, other):
		self._transferred_bytes += other
		return self
	def __div__(self, other):
		return self._transferred_bytes / other
	def __floordiv__(self, other):
		return self._transferred_bytes // other
	def __gt__(self, other):
		return self._transferred_bytes > other

class threadwrap(threading.Thread):
	"""docstring for threadwrap"""
	# pomocni trida pro clone_server a migrate_server
	# spousti vlanko ve kterem pak bezi tok dat lv->socket (na zdroji) nebo socket->lv (na cili)
	
	def __init__(self, func, args, transferred_bytes):
		threading.Thread.__init__(self)
		self.func = func
		self.args = args
		self.transferred_bytes = transferred_bytes
		self.result = None
		self.start()
	def run(self):
		self.call(self.func, self.args, self.transferred_bytes)
	def call(self, func, args, transferred_bytes):
		try: self.result = func(*args, transferred_bytes = transferred_bytes)
		except Exception, e: self.result = e
		return self.result

def test(*args,**kwargs):
	"""docstring for test"""
	return args

def test_progress(*args,**kwargs):
	"""docstring for test"""
	for i in range(100):
		kwargs['progress'].set(i/100.0)
		time.sleep(1)
	return args

def error(*args,**kwargs):
	"""docstring for test"""
	raise Exception('test exception: ' + str(args))

def close_socket(s):
	"""docstring for close_socket"""
	# zavre socket
	# vstup: socket
	err = ""
	try: s.shutdown(socket.SHUT_RDWR)
	except Exception, e: err += str(e)
	try: s.close()
	except Exception, e: err += "\n"+str(e)
	if len(err) > 0:
		raise Exception(err.strip())

def open_server_socket(data):
	"""docstring for open_server_socket"""
	# otevre server socket
	# vstup: json, src_nod_ip - ip adresa na ktere se otevre socket, vyber portu je ponechan nahode, socket_timeout - timeout na sitovy prenos
	# povoleny pocet spojeni na socket je 1
	# vystup: socket
	s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
	s.bind((data['src_nod_ip'], 0))
	s.listen(1)
	s.settimeout(data['socket_timeout'])
	return s

def connect_to_server_socket(data):
	"""docstring for connect_to_server_socket"""
	# pripoji se server socket
	# vstup: json, src_nod_ip a port - adresa a port na ktery se chceme pripojit, socket_timeout - timeout na sitovy prenos
	# vystup: socket
	s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
	s.settimeout(data['socket_timeout'])
	s.connect((data['src_nod_ip'], data['port']))
	return s

def open_dio(lv_name, mode = None):
	"""docstring for open_dio"""
	# otevre lv disk jako dio objekt v uvedenom mode (default RDONLY)
	path = "/dev/%s/%s" % (volume.VG_NAME,lv_name)
	dio = dioutil.DioFile()
	if mode == None: dio.open(path)
	else: dio.open(path, os.O_WRONLY)
	dio.seek(0)
	return dio

def lv2socket(data, transferred_bytes = None):
	"""docstring for lv2socket"""
	# pomocni funkce pro clone_server a migrate_server
	# na jiz otevrenem socketu ceka na pripojeni cile (overuje se ip adresa, jinak je spojeni zamitnuto)
	# z jiz otevreneho disku pak po blocich kopiruje data na socket
	# funkce se spousti ve vlaknu threadwrap
	# aktualni objem jiz prenesenych dat je zapisovan do transportniho objektu TRANSFERRED_BYTES
	# vstup json, povinne src_diofile, socket, allowed_ip
	# nepovinne blockSize (default 4 MiB) - nastavuje velikost bloku ktery zdroj posila, socket_timeout (default 60 s) - timeout na sitovy prenos
	# default se nastavi take pokud budou hodnoty nevalidni
	# vystup pocet prenesenych bytu jako int
	
	dio = data["dio"]
	s = data["socket"]
	allowed_ip = data["dst_nod_ip"]
	try: socket_timeout = int(data['socket_timeout'])
	except: socket_timeout = 60
	try: blockSize = data["blocksize"]
	except: blockSize = 4*1024*1024
	lv_size = dio.getsize()
	while True:
		try:
			conn, addr = s.accept()
		except:
			dio.close()
			try: close_socket(s)
			except: pass
			raise
		if addr[0] == allowed_ip: break
		else: conn.close()
	conn.settimeout(socket_timeout)
	transf_b = 0
	for i in range(lv_size//blockSize):
		rs = ws = es = []
		try:
			rs, ws, es = select.select([], [conn], [], 1)
		
		except:
			dio.close()
			conn.close()
			try: 
				close_socket(s)
				
			except: 
				pass
				
			raise
		
		if(len(ws) == 0):
			continue
			
		try: 
			conn.sendall(dio.read(blockSize))
		except: 
			dio.close()
			conn.close()
			try: close_socket(s)
			except: pass
			raise
		transf_b += blockSize
		if isinstance(transferred_bytes,TRANSFERRED_BYTES): transferred_bytes += blockSize
	if lv_size%blockSize > 0:
		try: 
			conn.sendall(dio.read(lv_size%blockSize))
		except: 
			dio.close()
			conn.close()
			try: close_socket(s)
			except: pass
			raise
		transf_b += lv_size%blockSize
		if isinstance(transferred_bytes,TRANSFERRED_BYTES): transferred_bytes += lv_size%blockSize
	dio.close()
	conn.close()
	try: close_socket(s)
	except: pass
	return transf_b

def socket2lv(data, transferred_bytes = None):
	"""docstring for socket2lv"""
	# pomocni funkce pro clone_server a migrate_server
	# navaze spojeni na server socket (zdroj) jako klient a kopiruje prijimana data ze socketu na disk
	# funkce se spousti ve vlaknu threadwrap
	# aktualni objem jiz prenesenych dat je zapisovan do transportniho objektu TRANSFERRED_BYTES
	# vstup json, povinne lv_name, ip, port
	# nepovinne socket_timeout (default 60 s) - timeout na sitovy prenos
	# default se nastavi take pokud budou hodnoty nevalidni
	# vystup pocet prenesenych bytu jako int
	
	lv_name = str(data['lv_name'])
	host = str(data['src_nod_ip'])
	port = int(data['port'])
	try: socket_timeout = int(data['socket_timeout'])
	except: socket_timeout = 60
	try: blockSize = data["blocksize"]
	except: blockSize = 4*1024*1024
	dio = open_dio(lv_name,mode=os.O_WRONLY)
	s = None
	
	try:
		s = connect_to_server_socket(data)
		
	except Exception,e:
		dio.close()
		try: 
			if(s != None):
				close_socket(s)
			
		except: 
			pass
			
		raise Exception(str(e))
		
	transf_b = 0
	while True:
		rs = ws = es = []
		try:
			rs, ws, es = select.select([s], [], [], 1)
		
		except:
			dio.close()
			conn.close()
			try: 
				close_socket(s)
				
			except: 
				pass
				
			raise
			
		if(len(rs) == 0):
			continue
		
		recv_data = s.recv(blockSize)
		if not recv_data: break
		dio.write(recv_data)
		transf_b += len(recv_data)
		if isinstance(transferred_bytes,TRANSFERRED_BYTES): transferred_bytes += len(recv_data)
	dio.close()
	try: close_socket(s)
	except: pass
	return transf_b

def get_name_from_uuid(uuidstr):
	"""docstring for get_name_from_uuid"""
	# z xml souboru vyparsuje jmeno
	conn = libvirt.open()
	dom = conn.lookupByUUIDString(uuidstr)
	xml = parseString(dom.XMLDesc())
	name = str(xml.getElementsByTagName('name')[0].childNodes[0].data)	
	conn.close()
	return name

def get_uuid_from_name(name):
	"""docstring for get_uuid_from_name"""
	uuidstr = None
	conn = libvirt.open()
	dom = conn.lookupByName(name)
	if dom != None:
		uuidstr = dom.UUIDString()
	conn.close()
	return uuidstr

def floppy_with_kickstart(vh_name,ks_path,ssh_keys):
	"""docstring for floppy_with_kickstart"""
	# pomocni funkce pro define_server
	# pripravi disketu s kickstartem a ssh klicema
	subprocess.check_call("dd if=/dev/zero of=/tmp/floppy_%s.img count=1440 bs=1k" % vh_name, shell=True) # vytvarime prazdnou disketu
	subprocess.check_call("/sbin/mkfs.msdos /tmp/floppy_%s.img" % vh_name, shell=True)
	try:
		request = urllib2.Request(ks_path)
		ks_content = urllib2.urlopen(request).read()
		open('/tmp/ks_%s.cfg' % vh_name,'w').write(ks_content)
		subprocess.check_call("mcopy -i /tmp/floppy_%s.img /tmp/ks_%s.cfg ::/ks.cfg" % (vh_name,vh_name), shell=True)# copy kickstart
	except:
		pass

	fd = open('/tmp/%s.authorized_keys' % vh_name,'w')
	for k in ssh_keys:
		fd.write(k['key'] + '\n')

	fd.close()
	subprocess.check_call("mcopy -i /tmp/floppy_%s.img /tmp/%s.authorized_keys ::/authorized_keys" % (vh_name,vh_name), shell=True)
	return [True,'']

def virsh_xml(vhost_data):
	"""docstring for virsh_xml"""
	# pomocni funkce pro define_server
	# pripravi xml pro libvirt
	
	drive_letters = map(chr,range(ord('a'),ord('z')+1,1))
	cdrom_letters = map(chr,range(ord('a'),ord('z')+1,1))
	system_features = vhost_data['system_features'].split(',')
	
	if not vhost_data.has_key('autostart'):
		try: vhost_data['autostart'] = get_autostart_server(data)
		except: pass
	xml = parse(os.path.join(os.path.dirname(__file__),"virtual-template.xml"))
	
	xml.getElementsByTagName('name')[0].childNodes[0].data = vhost_data['name']
	xml.getElementsByTagName('uuid')[0].childNodes[0].data = vhost_data['uuid']
	xml.getElementsByTagName('memory')[0].childNodes[0].data = vhost_data['memory']
	xml.getElementsByTagName('currentMemory')[0].childNodes[0].data = vhost_data['memory']
	xml.getElementsByTagName('vcpu')[0].childNodes[0].data = str(vhost_data['vcpu'])
	xml.getElementsByTagName('cpu')[0].getElementsByTagName('topology')[0].setAttribute('cores', str(vhost_data['vcpu']))
	# xml.getElementsByTagName('cpu')[0].getElementsByTagName('topology')[0].setAttribute('threads', str(vhost_data['threads']))
	
	# narvat do template
	vapic = xml.createElement('vapic')
	vapic.setAttribute('state','on')
	spinlocks = xml.createElement('spinlocks')
	spinlocks.setAttribute('state','on')
	spinlocks.setAttribute('retries','8191')
	if 'hyperv' in system_features:
		hyperv = xml.getElementsByTagName('hyperv')[0]
		# s timhle virtualy po migraci nebootuji
		# https://bugzilla.redhat.com/show_bug.cgi?id=1091818
		# https://rhn.redhat.com/errata/RHSA-2015-0290.html
		# opraveno v kernel-3.10.0-229.el7.x86_64.rpm
		# zatim neni v CentOSu
		#hyperv.appendChild(vapic)
		hyperv.appendChild(spinlocks)
		
		hypervclock = xml.createElement('timer')
		hypervclock.setAttribute('name','hypervclock')
		hypervclock.setAttribute('present','yes')
		clock = xml.getElementsByTagName('clock')[0]
		clock.appendChild(hypervclock)
	
	commandline = xml.getElementsByTagName('qemu:commandline')[0]
	arg = xml.createElement('qemu:arg')
	arg.setAttribute('value', '-qmp')
	commandline.appendChild(arg)
	arg = xml.createElement('qemu:arg')
	arg.setAttribute('value', 'unix:/var/lib/libvirt/qemu/%s.qmpcustom,server,nowait' % (vhost_data['name'],))
	commandline.appendChild(arg)
	

	
	# narvat do template - end
	
	devices = xml.getElementsByTagName('devices')[0]
	
	devices.getElementsByTagName('serial')[0].getElementsByTagName('source')[0].setAttribute('path', '/var/lib/libvirt/qemu/'+vhost_data['name']+'.com1')
	devices.getElementsByTagName('channel')[0].getElementsByTagName('source')[0].setAttribute('path', '/var/lib/libvirt/qemu/'+vhost_data['name']+'.vport')
	devices.getElementsByTagName('channel')[1].getElementsByTagName('source')[0].setAttribute('path', '/var/lib/libvirt/qemu/'+vhost_data['name']+'.agent')
	
	# interfaces 
	for iface in vhost_data['interfaces']:
		mac = iface['mac'].lower()
		vxlan_id = iface['vxlan_id'].lower()
		vlan_id = iface['vlan_id']
		
		interface = devices.appendChild(xml.createElement('interface'))
		devices.appendChild(interface)
		
		interface.appendChild(xml.createElement('model')).setAttribute('type', vhost_data['nic_type'])
		interface.appendChild(xml.createElement('mac')).setAttribute('address', mac)
		interface.appendChild(xml.createElement('driver')).setAttribute('name', 'vhost')
		interface.getElementsByTagName('driver')[0].setAttribute('ioeventfd','on')
		source = interface.appendChild(xml.createElement('source'))
		target = interface.appendChild(xml.createElement('target'))

		vlan_id = int(vlan_id)
		vxlan_id = vxlan_id.lower()
		if vlan_id > 1:
			source.setAttribute('bridge', 'bx%s.%d' % (vxlan_id,vlan_id))
		else:
			source.setAttribute('bridge', 'bx%s' % (vxlan_id,))
		target.setAttribute('dev', 'vm%s' % (mac.replace(':',''),))
		
		interface.setAttribute('type', 'bridge')
		# filterref = interface.appendChild(xml.createElement('filterref'))
		# filterref.setAttribute('filter', 'open-ip-policy')
		# param = filterref.appendChild(xml.createElement('parameter'))
		# param.setAttribute('name', 'MAC')
		# param.setAttribute('value', mac)
	# interfaces - end
	
	# KICKSTART pro CENTOS
	#if re.search('custom-centos', vhost_data['iso']):
	if (True):
		fddisk = xml.createElement("disk") # tag disk
		fddisk.setAttribute('type','file')
		fddisk.setAttribute('device','floppy')
		fddriver = xml.createElement("driver") # tag driver
		fddriver.setAttribute('name', 'qemu')
		fddriver.setAttribute('type', 'raw')
		fdsource = xml.createElement("source") # tag source
		fdsource.setAttribute('file', '/tmp/floppy_%s.img' % vhost_data['name'])
		fdtarget = xml.createElement("target") # tag target
		fdtarget.setAttribute('dev', 'fda')
		fdtarget.setAttribute('bus', 'fdc')
		fddisk.appendChild(fddriver) #stavime hierarchii
		fddisk.appendChild(fdsource)
		fddisk.appendChild(fdtarget)
		xml.getElementsByTagName('devices')[0].appendChild(fddisk)
	
	# disk drives
	xml.getElementsByTagName('os')[0].appendChild(xml.createElement('boot')).setAttribute('dev', 'cdrom')
	xml.getElementsByTagName('os')[0].appendChild(xml.createElement('boot')).setAttribute('dev', 'hd')
	
	if vhost_data['disk_bus'] != 'scsi':
		xml.getElementsByTagName('devices')[0].removeChild(xml.getElementsByTagName('devices')[0].getElementsByTagName('controller')[0])
		
	disk = xml.getElementsByTagName('devices')[0].getElementsByTagName('disk')[0]
	drive_letter = drive_letters.pop(0)
	cdrom_letter = cdrom_letters.pop(0)
	cdrom = None
	if(len(xml.getElementsByTagName('devices')[0].getElementsByTagName('disk')) != 1):
		cdrom = xml.getElementsByTagName('devices')[0].getElementsByTagName('disk')[1]
		
	
	disk.getElementsByTagName('target')[0].setAttribute('bus',vhost_data['disk_bus'])
	disk.getElementsByTagName('source')[0].setAttribute('dev', vhost_data['disk_path'])
	
	if(vhost_data['disk_bus'] == 'scsi'):
		disk.getElementsByTagName('target')[0].setAttribute('dev','sd%s' % (drive_letter,))
		if(cdrom != None):
			cdrom.getElementsByTagName('target')[0].setAttribute('dev','hd%s' % (cdrom_letter,))
	
	elif(vhost_data['disk_bus'] == 'virtio'):
		disk.getElementsByTagName('target')[0].setAttribute('dev','vd%s' % (drive_letter,))
		if(cdrom != None):
			cdrom.getElementsByTagName('target')[0].setAttribute('dev','hd%s' % (cdrom_letter,))
		
	elif(vhost_data['disk_bus'] == 'ide'):
		disk.getElementsByTagName('target')[0].setAttribute('dev','hd%s' % (drive_letter,))
		if(cdrom != None):
			cdrom_letter = cdrom_letters.pop(0)
			cdrom.getElementsByTagName('target')[0].setAttribute('dev','hd%s' % (cdrom_letter,))
		
	
	if disk.getElementsByTagName('target')[0].getAttribute('bus') != 'virtio' and disk.getElementsByTagName('target')[0].getAttribute('bus') != 'scsi':
		if disk.getElementsByTagName('driver')[0].hasAttribute('ioeventfd'):
			disk.getElementsByTagName('driver')[0].removeAttribute('ioeventfd')
		if disk.getElementsByTagName('driver')[0].hasAttribute('event_idx'):
			disk.getElementsByTagName('driver')[0].removeAttribute('event_idx')
	disk.getElementsByTagName('driver')[0].setAttribute('cache', vhost_data['disk_cache'])
	
	cdrom = xml.getElementsByTagName('devices')[0].getElementsByTagName('disk')[1]
	if vhost_data.has_key('iso'):
		cdrom.getElementsByTagName('source')[0].setAttribute('file',vhost_data['iso'])
	else:
		cdrom.removeChild(cdrom.getElementsByTagName('source')[0])
	# disk2 = xml.getElementsByTagName('devices')[0].getElementsByTagName('disk')[2]
	# disk3 = xml.getElementsByTagName('devices')[0].getElementsByTagName('disk')[3]
	if('additional_isos' in vhost_data):
		for iso in vhost_data['additional_isos']:
			cdrom_letter = cdrom_letters.pop(0)
		
			cdrom = xml.createElement('disk')
			cdrom.setAttribute('type','file')
			cdrom.setAttribute('device','cdrom')
			cdrom_child = xml.createElement('driver')
			cdrom_child.setAttribute('name', 'qemu')
			cdrom_child.setAttribute('type', 'raw')
			cdrom_child.setAttribute('cache', 'default')
			cdrom.appendChild(cdrom_child)
			cdrom_child = xml.createElement('source')
			cdrom_child.setAttribute('file', iso)
			cdrom.appendChild(cdrom_child)
			cdrom_child = xml.createElement('target')
			cdrom_child.setAttribute('dev', 'hd%s' % (cdrom_letter, ))
			cdrom_child.setAttribute('bus', 'ide')
			cdrom.appendChild(cdrom_child)
			cdrom.appendChild(xml.createElement('readonly'))
			cdrom.appendChild(xml.createElement('shareable'))
			xml.getElementsByTagName('devices')[0].appendChild(cdrom)
	
	
	# disk drives - end
	
	vnc = devices.getElementsByTagName('graphics')[0]
	# vnc.setAttribute('type', str(vhost_data['display_type']))
	# vnc.setAttribute('listen', str(vhost_data['vnc_listen']))
	# vnc.setAttribute('port', str(vhost_data['vnc_port']))
	vnc.setAttribute('passwd', str(vhost_data['vnc_password']))
	
	xmlout = xml.toxml()
	# virt_path = '/usr/virt/'
	# conf_path = virt_path+'conf/'
	# conf_file = open(conf_path+vhost_data['name']+'.xml', "w")
	# conf_file.write(xmlout)
	# conf_file.close()
	return xmlout
	
def define_server(vhost_data,progress=None):
	"""docstring for define_server"""
	# vytvori disk
	# zadefinuje vps podle prichoziho vhost_data
	# pokud je pozadovano, pripravi instalacni iso
	# pripravi kickstart a ssh klice
	# vstup json, povinne vhost_data
	if progress != None:
		progress.set(0)
	
	volume.update_volume(vhost_data['name'],vhost_data['disk_space'],vhost_data.get('disk_units','g'))
	if vhost_data.has_key('libvirt_xml'): 
		libvirt_xml = vhost_data['libvirt_xml']
		
	else:
		vhost_data['disk_path'] = '/dev/%s/%s' % (volume.VG_NAME,vhost_data['name'])
		if(vhost_data.has_key('iso_url') and vhost_data['iso_url'] != None):
			isos = vhost_data['iso_url'].split(';')
			boot_iso = isos[0]
			additional_isos = isos[1:]
			c = cache.cache
			logger.info('Try retreive ISO {}'.format(boot_iso))
			path = c.save_iso(url=boot_iso, progress = progress)
			if(path == False):
				raise Exception('ISO not found or isn\'t bootable')
			
			vhost_data['iso'] = path
			
			paths = []
			for iso in additional_isos:
				logger.info('Try retreive ISO {}'.format(iso))
				path = c.save_iso(url = iso, only_bootable = False)
				if(path == False):
					raise Exception('ISO not found')
					
				paths.append(path)
		
			vhost_data['additional_isos'] = paths
			
		#pripravime disketu s kickstartem a SSH klicema
		floppy_with_kickstart(vhost_data['name'],vhost_data['ks_path'],vhost_data['ssh_keys'])
		libvirt_xml = virsh_xml(vhost_data)
	
	if progress != None:
		progress.set(0.98)
	
	update = False
	conn = libvirt.open()
	try:
		dom = conn.lookupByUUIDString(vhost_data['uuid'])
		update = True
		
	except:
		pass
		
	if(update):
		if('vnc_password' in vhost_data):
			res = subprocess.call(['virsh', 'qemu-monitor-command', vhost_data['name'], '--hmp', 'change vnc password %s' % (vhost_data['vnc_password'])])
			if(res != 0):
				raise Exception('change vnc password failed')
			
	conn.defineXML(libvirt_xml)
	conn.close()
	# provest update node config
	if progress != None:
		progress.set(0.99)
		
	c2padmin.config.config.get_node_status()
	
	return True
	
def prepare_migration_dest(vhost_data):
	volume.update_volume(vhost_data['name'],vhost_data['disk_space'],vhost_data.get('disk_units','g'))
	return True

def undefine_server(data,progress=None):
	"""docstring for undefine_server"""
	# oddefinuje vps a smaze disk
	# vstup json, povinne uuid, name
	
	conn = libvirt.open()
	dom = conn.lookupByUUIDString(data['uuid'])
	res = dom.undefine()
	conn.close()
	time.sleep(5)
	volume.remove_volume(data['name'])
	return True

def create_server(data,progress=None):
	"""docstring for create_server"""
	"""Provede prvni start systemu a odpojeni instalacnich medii.
	Pred touto funkci musi probehnout define_server."""
	conn = libvirt.open()
	dom = conn.lookupByUUIDString(data['uuid'])
	dom.create()
	try: # TODO - predelat na volani pres modul libvirt detachDeviceFlags libvirt.VIR_DOMAIN_AFFECT_CONFIG
		subprocess.check_call(['virsh', 'change-media', dom.name(), 'fda', '--eject', '--config'])
		subprocess.check_call(['virsh', 'change-media', dom.name(), 'hda', '--eject', '--config'])
	except:
		pass
	if get_autostart_server(data):
		set_autostart_server({'uuid':data['uuid'],'autostart':True})
		
	return True

def destroy_server(data,progress=None):
	"""docstring for destroy_server"""
	conn = libvirt.open()
	dom = conn.lookupByUUIDString(data['uuid'])
	dom.destroy()
	
	return True

def set_autostart_server(data,progress=None):
	"""docstring for set_autostart_server"""
	# zapne/vypne autostart vps do inactive xml a libvirt autostart
	# vstup json, povinne uuid, autostart (jinak se nic nenastavi)
	# TODO enable/disable watchdog keeping server still alive
	try: 
		autostart = bool(data['autostart'])
	except: 
		return [False, 'Bad autostart value']

	conn = libvirt.open(None)
	dom = conn.lookupByUUIDString(data['uuid'])
	xml = parseString(dom.XMLDesc(libvirt.VIR_DOMAIN_XML_SECURE | libvirt.VIR_DOMAIN_XML_INACTIVE))
	meta_xml = xml.getElementsByTagName('metadata')[0].getElementsByTagName('c2pauto:metadata')[0]
	if autostart == False:
		# disable watchdog
		dom.setAutostart(0)
		meta_xml.getElementsByTagName('autostart')[0].childNodes[0].data = 0
	if autostart == True:
		# enable watchdog
		dom.setAutostart(1)
		meta_xml.getElementsByTagName('autostart')[0].childNodes[0].data = 1
	conn.defineXML(xml.toxml())
	
	return True

def get_autostart_server(data,progress=None):
	"""docstring for get_autostart_server"""
	# zjisti hodnotu autostart z inactive xml
	# vstup json, povinne uuid
	conn = libvirt.open(None)
	dom = conn.lookupByUUIDString(data['uuid'])
	xml = parseString(dom.XMLDesc(libvirt.VIR_DOMAIN_XML_INACTIVE))
	meta_xml = xml.getElementsByTagName('metadata')[0].getElementsByTagName('c2pauto:metadata')[0]
	autostart = meta_xml.getElementsByTagName('autostart')[0].childNodes[0].data
	return autostart
	
def turnon_server(data,progress=None):
	"""docstring for turnon_server"""
	# startuje vps, musi byt jiz definovane
	# pokud dostane autostart, tak ho nastavi, nicmene pokud selze, tak nekontrolujem, hlavne aby se vps zaplo
	# pokud je first_start=True, pak dojde po zapnuti vps jeste k odpojeni instalacnich medii a zapnuti autostartu, uspech operace se vsak nevyzaduje
	# vstup json, povinne uuid, nepovinne autostart (default = nic se nenastavi), max_tries (default 5 pokusu) a first_start (default False)
	# default se nastavi take pokud bude hodnota nevalidni

	uuidstr = data['uuid']
	try: first_start = bool(data['first_start'])
	except: first_start = False
	try: max_tries = data['max_tries']
	except: max_tries = 5
	
	conn = libvirt.open()
	dom = conn.lookupByUUIDString(uuidstr)
	if dom.info()[0] not in [libvirt.VIR_DOMAIN_NOSTATE, libvirt.VIR_DOMAIN_SHUTOFF]:
		conn.close()
		return False
		
	tries = 0
	while True:
		if dom.info()[0] == libvirt.VIR_DOMAIN_RUNNING: break
		try:
			res = dom.create()
		except (IOError, libvirt.libvirtError):
			if tries < max_tries:
				tries += 1
				continue
			else:
				try: set_autostart_server({'uuid':data['uuid'],'autostart':False})
				except: pass
				conn.close()
				raise
		except:
			if dom.info()[0] != libvirt.VIR_DOMAIN_RUNNING:
				try: set_autostart_server({'uuid':data['uuid'],'autostart':False})
				except: pass
				conn.close()
				raise
			else:
				pass
		time.sleep(1)
	if first_start:
		try: # TODO - predelat na volani pres modul libvirt detachDeviceFlags libvirt.VIR_DOMAIN_AFFECT_CONFIG
			subprocess.check_call(['virsh', 'change-media', dom.name(), 'fda', '--eject', '--config'])
			subprocess.check_call(['virsh', 'change-media', dom.name(), 'hda', '--eject', '--config'])
		except:
			pass
		if get_autostart_server(data):
			set_autostart_server({'uuid':data['uuid'],'autostart':True})
	else:
		set_autostart_server(data)
	conn.close()
	return True
	
def eject_media(data, progress = None):
	uuidstr = data['uuid']
	target = data['target']
	live = '--live'
	try:
		live = '--live' if(bool(data['live'])) else '--config'
		
	except:
		pass
		
	try:
		conn = libvirt.open()
		dom = conn.lookupByUUIDString(uuidstr)
		subprocess.check_call(['virsh', 'change-media', dom.name(), target, '--eject', live, '--force'])
	
	except:
		return False
		
	return True
	

def turnoff_server(data,progress=None):
	"""docstring for turnoff_server"""
	# pokud funkce dostane timeout<0 cili nekonecny timeout, tak se jednou posle shutdownFlags, na vysledek se neceka a funkce hned konci
	# pokud funkce dostane timeout=0, tak se jednou posle shutdownFlags a pokud se vps hned nevypne, tak se hned posle destroy
	# jinak se v kolecku posila shutdownFlags az dokud se vps nevypne anebo nevyprsi timeout, pak se posle destroy
	# 	krome pripadu, ze hned prvni pokus o shutdownFlags selze, tehdy se nastavi timeout=0 cili nasledne se pak hned posle destroy
	# vstup json, povinne uuid
	# nepovidne timeout (default 90 s), default se nastavi take pokud bude hodnota nevalidni
	
	logger.info('Turnoff ' + str(data['uuid']))
	
	uuidstr = data['uuid']
	try: timeout = int(data['timeout'])
	except: timeout = 90

	conn = libvirt.open()
	dom = conn.lookupByUUIDString(uuidstr)
	if dom.info()[0] == libvirt.VIR_DOMAIN_SHUTOFF: 
		conn.close()
		logger.info('Turnedoff ' + str(data['uuid']))
		return False
		
	set_autostart_server({'uuid':data['uuid'],'autostart':False})
	try: 
		res = dom.shutdownFlags(libvirt.VIR_DOMAIN_REBOOT_ACPI_POWER_BTN)
		
	except: 
		timeout = 0
		
	if timeout < 0:
		conn.close()
		logger.info('Turnoff signal send ' + str(data['uuid']))
		return True
		
	expiry = time.time() + timeout
	try: 
		dominfo = dom.info()[0]
		
	except:	
		dominfo = None
		
	time.sleep(5)
	while dominfo != libvirt.VIR_DOMAIN_SHUTOFF:
		if time.time() >= expiry:
			try:
				res = dom.destroy()
			except:
				dom = conn.lookupByUUIDString(uuidstr)
				time.sleep(5)
				if dom.info()[0] == libvirt.VIR_DOMAIN_SHUTOFF:
					break # Domain destroyed
					
				else: 
					conn.close()
					raise Exception('Unable to destroy domain.')
			else:
				break # Domain destroyed
		else:
			try: 
				res = dom.shutdownFlags(libvirt.VIR_DOMAIN_REBOOT_ACPI_POWER_BTN)
				
			except: 
				pass
				
			time.sleep(5)
			
		try: 
			dominfo = dom.info()[0]
			
		except:	
			pass
			
	conn.close()
	logger.info('Turnedoff ' + str(data['uuid']))
	
	return True
	
def suspend_server(data, progress = None):
	logger.info('Suspend ' + str(data['uuid']))
	
	uuidstr = data['uuid']
	try: timeout = int(data['timeout'])
	except: timeout = 90
	
	conn = libvirt.open()
	dom = conn.lookupByUUIDString(uuidstr)
	if dom.info()[0] != libvirt.VIR_DOMAIN_RUNNING: 
		conn.close()
		logger.info('VPS ' + str(data['uuid']) + ' is not in running state')
		return False
		
	try: 
		res = dom.suspend()
		if(timeout <= 0):
			conn.close()
			logger.info('Suspend ' + str(data['uuid']) + ' sended')
			return True
			
	except:
		conn.close()
		logger.warning('Suspending of ' + str(data['uuid']) + ' failed')
		return False
	
	time.sleep(1)	
	expiry = time.time() + timeout
	try: 
		dominfo = dom.info()[0]
		
	except:	
		dominfo = None
		
	while dominfo != libvirt.VIR_DOMAIN_PAUSED:
		if time.time() >= expiry:
			conn.close()
			logger.warning('Suspending of ' + str(data['uuid']) + ' is timeouted')
			return False
			
		else:
			try: 
				res = dom.suspend()
				
			except:
				logger.warning('Suspending of ' + str(data['uuid']) + ' failed')
				
				
			time.sleep(5)
			
		try: 
			dominfo = dom.info()[0]
			
		except:	
			pass
			
	conn.close()
	logger.info('Suspended ' + str(data['uuid']))
	
	return True
	
def unsuspend_server(data, progress = None):
	logger.info('Unsuspend ' + str(data['uuid']))
	
	uuidstr = data['uuid']
	try: timeout = int(data['timeout'])
	except: timeout = 90
	
	conn = libvirt.open()
	dom = conn.lookupByUUIDString(uuidstr)
	if dom.info()[0] != libvirt.VIR_DOMAIN_PAUSED: 
		conn.close()
		logger.info('VPS ' + str(data['uuid']) + ' is not in paused state')
		return False
		
	try: 
		res = dom.resume()
		if(timeout <= 0):
			conn.close()
			logger.info('Unsuspend ' + str(data['uuid']) + ' sended')
			return True
			
	except:
		conn.close()
		logger.warning('Unsuspending of ' + str(data['uuid']) + ' failed')
		return False
	
	time.sleep(1)	
	expiry = time.time() + timeout
	try: 
		dominfo = dom.info()[0]
		
	except:	
		dominfo = None
		
	while dominfo == libvirt.VIR_DOMAIN_PAUSED:
		if time.time() >= expiry:
			conn.close()
			logger.warning('Unsuspending of ' + str(data['uuid']) + ' is timeouted')
			return False
			
		else:
			try: 
				res = dom.resume()
				
			except:
				logger.warning('Unsuspending of ' + str(data['uuid']) + ' failed')
				
				
			time.sleep(5)
			
		try: 
			dominfo = dom.info()[0]
			
		except:	
			pass
			
	conn.close()
	logger.info('Unsuspended ' + str(data['uuid']))
	
	return True

def restart_server(data,progress=None):
	"""docstring for turnoff_server"""
	# vstup json, povinne uuid, nepovidne timeout (default 90 s)
	# default se nastavi take pokud bude hodnota nevalidni

	try: 
		timeout = int(data['timeout'])
		
	except: 
		timeout = 90
		
	try: 
		data['autostart'] = bool(data['autostart'])
		
	except:	
		data['autostart'] = get_autostart_server(data)
	
	turnoff_server(data)
	turnon_server(data)
	
	return True

def remove_server(data,progress=None):
	"""docstring for remove_server"""
	# vps vypne, oddefinuje a zmaze disk
	# vstup json, povinne uui
	data['timeout'] = 0
	data['name'] = get_name_from_uuid(data['uuid'])	
	if('backup_host' not in data):
		data['backup_host'] = None
		
	if('backup_port' not in data):
		data['backup_port'] = None
		
	with c2padmin.config.node_config_lock:
		c2padmin.config.node_config['libvirt']['domains'][data['uuid']]['backups']['schedule'].set_dict({'enabled': False})
	
	c2padmin.backups.dispatcher.dispatcher_instance.remove_backups(data['name'])
	pending_backups = c2padmin.backups.dispatcher.dispatcher_instance.get_pending()
	if(data['name'] in pending_backups):
		raise c2padmin.commands.VPSBusy(60)
			
	turnoff_server(data)
	undefine_server(data)
	
	return True
	
def make_server_backup(data, progress = None):
	# {"uuid":"domain_uuid", "custom_name": "metadata name", "metadata" : {"key1": "value1", ...}}
	# custom_name, metadata - optional default ('', {})
	if('custom_name' not in data):
		data['custom_name'] = ''
		
	if('metadata' not in data):
		metadata = {}
		
	else:
		metadata = data['metadata']
		
	metadata.update({'custom_name': data['custom_name'], '__domain_xml__': c2padmin.config.node_config['libvirt']['domains'][data['uuid']]['xml']})
	
	return c2padmin.backups.dispatcher.dispatcher_instance.make_backup(data['uuid'], metadata)
	
def change_backup_type(data, progress = None):
	# {"server_name":"src_server_name", "name":"src_backup_name", "backup_host":"backup_server_addr", "backup_port":"backup_server_port"}
	# backup_host, backup_port - optional default (null, null)
	if('backup_host' not in data):
		data['backup_host'] = None
		
	if('backup_port' not in data):
		data['backup_port'] = None
		
	backup_list = filter(lambda x: x['path'] == data['name'], c2padmin.backups.types.BackupList(data['server_name']).get_list())
	if(len(backup_list) == 0):
		logger.warning('Backup %s not found' % (data['name'],))
		raise Exception('Backup %s not found' % (data['name'],))
		
	_client = c2padmin.backups.client.BackupClient()
	_client.connect(data['backup_host'], data['backup_port'])
	res = _client.change_backup_type(data['server_name'], data['name'])
	if(res):
		logger.info('Backup type changed')
		return True
		
	else:
		logger.warning('Backup type of %s couldn\'t be changed' % (data['name'],))
		raise Exception('Backup type of %s couldn\'t be changed' % (data['name'],))
		
def change_backup_metadata(data, progress = None):
	# {"server_name":"src_server_name", "name":"src_backup_name", "metadata": {"new": "metadata"}, "backup_host":"backup_server_addr", "backup_port":"backup_server_port"}
	# backup_host, backup_port - optional default (null, null)
	if('backup_host' not in data):
		data['backup_host'] = None
		
	if('backup_port' not in data):
		data['backup_port'] = None
		
	backup_list = filter(lambda x: x['path'] == data['name'], c2padmin.backups.types.BackupList(data['server_name']).get_list())
	if(len(backup_list) == 0):
		logger.warning('Backup %s not found' % (data['name'],))
		raise Exception('Backup %s not found' % (data['name'],))
		
	_client = c2padmin.backups.client.BackupClient()
	_client.connect(data['backup_host'], data['backup_port'])
	res = _client.change_metadata(data['name'], data['metadata'])
	if(res):
		logger.info('Backup metadata changed')
		return True
		
	else:
		logger.warning('Backup metadata of %s couldn\'t be changed' % (data['name'],))
		raise Exception('Backup metadate of %s couldn\'t be changed' % (data['name'],))

def make_server_image(data, progress = None):
	# {"uuid":"domain_uuid"}
	if(data['uuid'] not in c2padmin.config.node_config['libvirt']['domains']):
		logger.warning('Domain %s not found' % (uuid,))
		raise Exception('Domain %s not found' % (uuid,))
	
	if('custom_name' not in data):
		data['custom_name'] = ''
		
	metadata = {'custom_name': data['custom_name'], 'domain_xml': c2padmin.config.node_config['libvirt']['domains'][data['uuid']]['xml']}
	
	shutdown_data = {'uuid': data['uuid'], 'timeout': 60}	
	logger.info('Server %s turning off' % (data['uuid'],))
	turnoff_server(shutdown_data)
	logger.info('Server %s is turned off' % (data['uuid'],))
	domname = get_name_from_uuid(data['uuid'])
	snapshot = c2padmin.virt.volume.create_snapshot(domname)
	logger.info('Server %s turning on' % (data['uuid'],))
	turnon_server(data)
	logger.info('Server %s is turned on' % (data['uuid'],))
	return c2padmin.backups.dispatcher.dispatcher_instance.make_backup(data['uuid'], metadata, snapshot, True)
	
	# backup_job = BackupJob(domname, 'image', snapshot = snapshot, metadata = metadata)
	# backup_job.start()
	# logger.info('Make image started')
	# logger.info('Server %s turning on' % (data['uuid'],))
	# turnon_server(data)
	# logger.info('Server %s is turned on' % (data['uuid'],))
	# backup_job.join()
	# result = backup_job.get_result()
	# if(result[0] == 0):
	# 	logger.info('Make image finished')
	#
	# elif(result[0] not in [1, 2]):
	# 	logger.warning('Snapshot of {} created, save will be processed later'.format(data['uuid']))
	#
	# else:
	# 	logger.error('Make image of %s couldn\'t start' % (data['uuid'],))
	# 	raise Exception('Make image of {} couldn\'t start'.format(data['uuid']))
	#
	# return {'name': backup_job.get_backup_identifier()}

	
def make_server_restore(data, progress = None):
	# {"uuid":"dst_domain_uuid", "server_name":"src_server_name", "name":"src_backup_name", "public": "public/private_image(true/false)", "backup_host":"backup_server_addr", "backup_port":"backup_server_port"}
	# public, backup_host, backup_port - optional default (false, null, null)
	if(data['uuid'] in c2padmin.config.node_config['libvirt']['domains']):
		if('public' not in data):
			data['public'] = False
			
		if('backup_host' not in data):
			data['backup_host'] = None
			
		if('backup_port' not in data):
			data['backup_port'] = None
				
		domain_xml = parseString(c2padmin.config.node_config['libvirt']['domains'][data['uuid']]['xml'])
		lv_re = re.compile('^.*HostVG.*$')
		dst_lv = None
		for disk in domain_xml.getElementsByTagName('disk'):
			
			source = disk.getElementsByTagName('source')
			if(len(source) == 0):
				continue
				
			source = source[0].getAttribute('dev')
			if(source != '' and lv_re.match(source)):
				dst_lv = source
				
		if(dst_lv == None):
			logger.warning('Destination LV not found')
			raise Exception('Destination LV not found')
		
		lv_name = dst_lv.rsplit('/', 1)
		lv_name = lv_name[len(lv_name) - 1]
		backup_list = filter(lambda x: x['path'] == data['name'], c2padmin.backups.types.BackupList(data['server_name'], data['public']).get_list())
		if(len(backup_list) == 0):
			logger.warning('Backup %s not found' % (data['name'],))
			raise Exception('Backup %s not found' % (data['name'],))
			
		lvs = filter(lambda x: x[0] == lv_name and x[1] == 'HostVG', c2padmin.config.node_config['lvm']['lvs'])
		lvsize = int(lvs[0][3][:-1])
		if(backup_list[0]['size'] > lvsize):
			logger.warning('Backup - destination size difference is {0:.2f} MB'.format((backup_list[0]['size'] - lvsize) / 1024.0 / 1024.0 ))
			if((backup_list[0]['size'] - lvsize) < (1024 * 1024 * 100)):
				logger.warning('Difference is less than 100 MB - trying resize')
				ret = os.system('lvresize -L{}b {} </dev/null >/dev/null 2>&1'.format(backup_list[0]['size'] , dst_lv))
				if(ret != 0):
					logger.error('LV resize failed')
					raise Exception('Backup is too big')
				
			else:
				logger.error('Difference is too big')
				raise Exception('Backup is too big')
		
		turnon = False
		manipulation_data = {'uuid': data['uuid'], 'timeout': 60}
		conn = libvirt.open()
		dom = conn.lookupByUUIDString(data['uuid'])
		if(dom.info()[0] != libvirt.VIR_DOMAIN_SHUTOFF):
			logger.info('Server %s turning off' % (data['uuid'],))
			try:
				turnon = turnoff_server(manipulation_data)
				logger.info('Server %s is turned off' % (data['uuid'],))
				
			except:
				logger.error('Server %s turnoff failed' % (data['uuid'],))
				raise Exception('Server turnoff failed')
		
		retVal = c2padmin.backups.dispatcher.dispatcher_instance.make_restore(data['uuid'], str(data['server_name']), data['name'], dst_lv, data['public'], progress)
		
		if(turnon):
			logger.info('Server %s turning on' % (data['uuid'],))
			try:
				turnon_server(manipulation_data)
				logger.info('Server %s is turned on' % (data['uuid'],))
				
			except:
				logger.error('Server %s turnon failed' % (data['uuid'],))
				raise Exception('Server turnon failed')
	
		return True
		
	logger.warning('Domain UUID: %s not found' % (data['uuid'],))	
	raise Exception('Domain UUID: %s not found' % (data['uuid'],))
	
def remove_server_backup(data, progress = None):
	# {"server_name":"src_server_name", "name":"src_backup_name", "backup_host":"backup_server_addr", "backup_port":"backup_server_port"}
	# backup_host, backup_port, deferred - optional default (null, null, false)
	if('backup_host' not in data):
		data['backup_host'] = None
		
	if('backup_port' not in data):
		data['backup_port'] = None
	
	if('deferred' in data and data['deferred'] == True):
		c2padmin.backups.dispatcher.dispatcher_instance.remove_backups(server_name, [data['name']])
		return True
	
	if(c2padmin.config.node_config['backup_server']['unavailable_timestamp'] == None):
		backup_list = filter(lambda x: x['path'] == data['name'], c2padmin.backups.types.BackupList(data['server_name']).get_list())
		if(len(backup_list) == 0):
			logger.warning('Backup %s not found' % (data['name'],))
			raise Exception('Backup %s not found' % (data['name'],))
		
		_client = c2padmin.backups.client.BackupClient()
		_client.connect(data['backup_host'], data['backup_port'])
		_client.removeBackup(data['server_name'], data['name'])
		logger.info('Backup removed')
		return True
		
	else:
		return False
	
def set_backup_scheduler(data, progress = None): 
	# {"uuid":"domain_uuid", "config": {"interval":backup_period,"enabled":true,"day_of_week":[0-monday,...],"time_of_day":[["time_from","time_to"]],"keep_rules":[[period,no_of_backups]]}, "backup_host":"backup_server_addr", "backup_port":"backup_server_port"}
	if('backup_host' not in data):
		data['backup_host'] = None
		
	if('backup_port' not in data):
		data['backup_port'] = None
		
	if(data['uuid'] in c2padmin.config.node_config['libvirt']['domains']):
		server_name = get_name_from_uuid(data['uuid'])	
		with c2padmin.config.node_config_lock:
			c2padmin.config.node_config['libvirt']['domains'][data['uuid']]['backups']['schedule'].set_dict(data['config'])
		
		if(not data['config']['enabled']):
			c2padmin.backups.dispatcher.dispatcher_instance.remove_backups(server_name, btype = 'auto')
		
		return True
		
	raise Exception('Domain UUID: %s not found' % (data['uuid'],))
	
def get_backup_scheduler(data, progress = None):
	# {"uuid":"domain_uuid"}
	if(data['uuid'] in c2padmin.config.node_config['libvirt']['domains']):
		return c2padmin.config.node_config['libvirt']['domains'][data['uuid']]['backups']['schedule'].get_dict()
		
	raise Exception('Domain UUID: %s not found' % (data['uuid'],))

def clone_server(data, progress = None):
	# pokud server bezi, vypne ho udela snapshot a zapne
	with c2padmin.config.node_system_locks['clone_migrate']:
		BLOCK_SIZE = 4 * 1024 * 1024
		SOCKET_TIMEOUT = 60
		TIMEOUT = 90
		SNAP_SIZE = 50
	
		universe = network.get_universe()
	
		src_data = {}
		src_data['uuid'] = str(data['src_vps_uuid'])
		src_data['node_uuid'] = c2padmin.config.node_config['uuid']
		src_data['blocksize'] = BLOCK_SIZE
		src_data['lv_name'] = get_name_from_uuid(data['src_vps_uuid'])
		src_data['name'] = src_data['lv_name']
	
		try: 
			src_data['autostart'] = bool(data['autostart'])
		
		except: 
			src_data['autostart'] = get_autostart_server(src_data)
	
		dst_data = data['dst_vhost_data']
		dst_data['lv_name'] = str(data['dst_vhost_data']['name'])
	
		try: 
			dst_data['autostart'] = bool(data['dst_vhost_data']['autostart'])
		
		except: 
			dst_data['autostart'] = src_data['autostart']
	
		try:
			turnoff_server(src_data)
		
		except: 
			logger.error('Couldn\'t turnoff server')
			raise
		 
		try: 
			src_data['lv_name'] = volume.create_snapshot(src_data['lv_name'],size = SNAP_SIZE)
	
		except: 
			if(src_data['autostart']): 
				try: 
					turnon_server(src_data)
					
				except: 
					logger.error('Couldn\'t turnon server')
		
			logger.error('Couldn\'t create snapshot')			
			raise
	
		try: 
			turnon_server(src_data)
		
		except: 
			logger.error('Couldn\'t start source server')
		
		if(src_data['node_uuid'] == str(data['dst_nod_uuid'])):
			try: 
				define_server(dst_data)
			
			except Exception,e:
				try: 
					undefine_server(dst_data)
				
				except:
					logger.error('Couldn\'t undefine failed clone')
				
				try: 
					volume.remove_volume(src_data['lv_name'])
				
				except: 
					logger.error('Couldn\'t remove source snapshot')
					
				raise Exception(str(e))
		
			try:
				src_dio = open_dio(src_data['lv_name'])
				dst_dio = open_dio(dst_data['lv_name'], mode=os.O_WRONLY)
				lv_size = src_dio.getsize()
				update_counter = 0
				for i in range(lv_size // src_data['blocksize']):
					dst_dio.write(src_dio.read(src_data['blocksize']))
				
				
					if(progress != None):
						if(update_counter % 10 == 0):
							progress.set(float(i * src_data['blocksize']) / float(lv_size))
							update_counter = 0
				
						else:
							update_counter += 1

				if(lv_size % src_data['blocksize'] > 0):
					dst_dio.write(src_dio.read(lv_size % src_data['blocksize']))
				
				src_dio.close()
				dst_dio.close()
			
			except Exception,e:
				try: 
					src_dio.close()
				
				except: 
					logger.error('Couldn\'t close src file')
				
				try: 
					dst_dio.close()
				
				except:	
					logger.error('Couldn\'t close dst file')
				
				try: 
					undefine_server(dst_data)
				
				except:
					logger.error('Couldn\'t undefine failed clone')
				
				try: 
					volume.remove_volume(src_data['lv_name'])
				
				except: 
					logger.error('Couldn\'t remove source snapshot')
					
				raise Exception(str(e))
			
			try: 
				volume.remove_volume(src_data['lv_name'])
			
			except: 
				logger.error('Couldn\'t remove source snapshot')
					
			set_autostart_server(dst_data)
			if dst_data['autostart']: 
				turnon_server(dst_data)	

		else:
			src_data['socket_timeout'] = SOCKET_TIMEOUT
			src_data['timeout'] = TIMEOUT
			src_data['src_nod_ip'] = c2padmin.config.node_config['unicast_ip']
			src_data['dst_nod_ip'] = universe[str(data['dst_nod_uuid'])]['unicast_ip']
		
			dst_data['socket_timeout'] = SOCKET_TIMEOUT
			dst_data['src_nod_ip'] = src_data['src_nod_ip']
			dst_data['dst_nod_ip'] = universe[str(data['dst_nod_uuid'])]['unicast_ip']
		
			try:
				nc = network.remote_fcall("virt.guest.define_server",dst_data)
			
			except Exception,e:
				try: 
					nc = network.remote_fcall("virt.guest.undefine_server",dst_data)
				
				except: 
					logger.error('Couldn\'t undefine failed clone')
				
				try: 
					volume.remove_volume(src_data['lv_name'])
				
				except: 
					logger.error('Couldn\'t remove source snapshot')
			
				raise Exception(str(e))
		
			dio = None
			lv_size = None
			s = None
			port = None	
			try:
				dio = open_dio(src_data['lv_name'])
				lv_size = dio.getsize()
				s = open_server_socket(src_data)
				port = s.getsockname()[1]
			
			except Exception,e: 
				try: 
					dio.close()
				
				except: 
					logger.error('Couldn\'t close src file')
				
				try: 
					close_socket(s)
				
				except:
					logger.error('Couldn\'t close src socket')
				
				try: 
					nc = network.remote_fcall("virt.guest.undefine_server", dst_data)
				
				except: 
					logger.error('Couldn\'t undefine failed clone')
				
				try: 
					volume.remove_volume(src_data['lv_name'])
				
				except: 
					logger.error('Couldn\'t remove source snapshot')
				
				raise Exception(str(e))

			transferred_bytes = TRANSFERRED_BYTES()
			src_data['dio'] = dio
			src_data['socket'] = s
			dst_data['port'] = port
		
			src_th = threadwrap(lv2socket, [src_data], transferred_bytes = transferred_bytes)
			dst_th = threadwrap(network.remote_fcall,["virt.guest.socket2lv",dst_data],transferred_bytes=None)
		
			prev_transferred_bytes = 0
			while src_th.isAlive() or dst_th.isAlive():
				if(transferred_bytes > 0 and int(transferred_bytes) != prev_transferred_bytes):
					prev_transferred_bytes = int(transferred_bytes)
					if(progress != None):
						progress.set(transferred_bytes / float(lv_size))
				
				time.sleep(1)
				
			try: 
				dio.close()
			
			except: 
				pass
			
			try: 
				close_socket(s)
			
			except: 
				pass
			
			try: 
				dst_bytes = int(dst_th.result)
				src_bytes = int(src_th.result)
			
			except: 
				try:
					 nc = network.remote_fcall("virt.guest.undefine_server",dst_data)
				 
				except: 
					logger.error('Couldn\'t remove source snapshot')
				
				try: 
					volume.remove_volume(src_data['lv_name'])
				
				except: 
					logger.error('Couldn\'t remove source snapshot')
			
				print dst_th.result, src_th.result
				raise Exception("%s;%s" % (str(dst_th.result),str(src_th.result)))
			
			if dst_bytes != src_bytes:
				try: 
					nc = network.remote_fcall("virt.guest.undefine_server", dst_data)
				
				except: 
					logger.error('Couldn\'t undefine failed clone')
				try: 
					volume.remove_volume(src_data['lv_name'])
				
				except: 
					logger.error('Couldn\'t remove source snapshot')
				
				raise Exception("Data transfer failed %s/%s" % (src_bytes, dio_size))


			nc = network.remote_fcall("virt.guest.set_autostart_server", dst_data)
			if dst_data['autostart']: 
				nc = network.remote_fcall("virt.guest.turnon_server", dst_data)
	
	return True
	
def migrate_server(data, progress = None):
	# pokud server bezi, vypne ho udela snapshot a zapne
	with c2padmin.config.node_system_locks['clone_migrate']:
		BLOCK_SIZE = 4 * 1024 * 1024
		SOCKET_TIMEOUT = 60
		TIMEOUT = 90
	
		universe = network.get_universe()
	
		src_data = {}
		src_data['uuid'] = str(data['src_vps_uuid'])
		src_data['lv_name'] = get_name_from_uuid(data['src_vps_uuid'])
		src_data['name'] = src_data['lv_name']
		src_data['socket_timeout'] = SOCKET_TIMEOUT
		src_data['timeout'] = TIMEOUT
		src_data['blocksize'] = BLOCK_SIZE
		src_data['src_nod_ip'] = c2padmin.config.node_config['unicast_ip']
		src_data['dst_nod_ip'] = universe[str(data['dst_nod_uuid'])]['unicast_ip']
		src_data['autostart'] = get_autostart_server(src_data)
		src_xml = None
		
		dst_data = {}
		dst_data['uuid'] = str(data['src_vps_uuid'])
		if('dst_vhost_data' in data and ('live' not in data or not bool(data['live']))):
			dst_data = data['dst_vhost_data']
		
		else:
			conn = libvirt.open(None)
			dom = conn.lookupByUUIDString(src_data['uuid'])
			xml = parseString(dom.XMLDesc(libvirt.VIR_DOMAIN_XML_SECURE | libvirt.VIR_DOMAIN_XML_INACTIVE))
			dst_data['libvirt_xml'] = xml.toxml()
			active_xml = parseString(dom.XMLDesc())
			conn.close()
		
		dst_data['socket_timeout'] = SOCKET_TIMEOUT
		dst_data['src_nod_ip'] = src_data['src_nod_ip']
		dst_data['dst_nod_ip'] = universe[str(data['dst_nod_uuid'])]['unicast_ip']
		dst_data['lv_name'] = src_data['lv_name']
		dst_data['name'] = src_data['name']
		if('disk_space' not in dst_data):
			dst_data['disk_space'] = int(volume.get_lv(src_data['lv_name'],units='B')[1])
			dst_data['disk_units'] = 'B'
	
		try: 
			dst_data['autostart'] = bool(data['autostart'])
		
		except: 
			dst_data['autostart'] = src_data['autostart']
		
		if(src_data['src_nod_ip'] == str(data['dst_nod_uuid'])):
			logger.error('Pointless local migration. Terminated.')
			raise Exception('Pointless local migration. Terminated.')

		else:
			if('live' not in data or not bool(data['live'])):
				try:
					turnoff_server(src_data)
		
				except: 
					logger.error('Couldn\'t turnoff server')
					raise
			
				try:
					nc = network.remote_fcall("virt.guest.define_server",dst_data)
					
				except Exception,e:
					try: 
						nc = network.remote_fcall("virt.guest.undefine_server",dst_data)
				
					except: 
						logger.error('Couldn\'t undefine failed server')
				
			
					raise Exception(str(e))
				
				dio = None
				lv_size = None
				s = None
				port = None
		
				try:
					dio = open_dio(src_data['lv_name'])
					lv_size = dio.getsize()
					s = open_server_socket(src_data)
					port = s.getsockname()[1]
			
				except Exception,e: 
					try: 
						dio.close()
				
					except: 
						logger.error('Couldn\'t close src file')
				
					try: 
						close_socket(s)
				
					except:
						logger.error('Couldn\'t close src socket')
				
					try: 
						nc = network.remote_fcall("virt.guest.undefine_server", dst_data)
				
					except: 
						logger.error('Couldn\'t undefine failed server')
				
					raise Exception(str(e))

				transferred_bytes = TRANSFERRED_BYTES()
				src_data['dio'] = dio
				src_data['socket'] = s
				dst_data['port'] = port
		
				src_th = threadwrap(lv2socket, [src_data], transferred_bytes = transferred_bytes)
				dst_th = threadwrap(network.remote_fcall,["virt.guest.socket2lv",dst_data],transferred_bytes=None)
		
				prev_transferred_bytes = 0
				while src_th.isAlive() or dst_th.isAlive():
					if(transferred_bytes > 0 and int(transferred_bytes) != prev_transferred_bytes):
						prev_transferred_bytes = int(transferred_bytes)
						if(progress != None):
							progress.set(transferred_bytes / float(lv_size))
				
					time.sleep(1)
				
				try: 
					dio.close()
			
				except: 
					pass
			
				try: 
					close_socket(s)
			
				except: 
					pass
			
				try: 
					dst_bytes = int(dst_th.result)
					src_bytes = int(src_th.result)
			
				except: 
					try:
						nc = network.remote_fcall("virt.guest.undefine_server",dst_data)
					   
					except: 
						logger.error('Couldn\'t undefine failed server')
				
			
					print dst_th.result, src_th.result
					raise Exception("%s;%s" % (str(dst_th.result),str(src_th.result)))
			
				if dst_bytes != src_bytes:
					try: 
						nc = network.remote_fcall("virt.guest.undefine_server", dst_data)
				
					except: 
						logger.error('Couldn\'t undefine failed server')
				
					raise Exception("Data transfer failed %s/%s" % (src_bytes, dio_size))
			
				try: 	
					undefine_server(src_data)
			
				except: 
					logger.error('Couldn\'t undefine source server')
		
				nc = network.remote_fcall("virt.guest.set_autostart_server", dst_data)
				if dst_data['autostart']: 
					nc = network.remote_fcall("virt.guest.turnon_server", dst_data)
					
			else:
				files = []
				disks = active_xml.getElementsByTagName('devices')[0].getElementsByTagName('disk')
				for disk in disks:
					if(disk.getAttribute('type') == 'file'):
						path = disk.getElementsByTagName('source')
						target = disk.getElementsByTagName('target')
						if(len(target) != 0):
							target = target[0].getAttribute('dev')
							
						else:
							target = None
							
						if(len(path) != 0):
							files.append([path[0].getAttribute('file'), target])
				
				for file_to_copy in files:
					if(file_to_copy[0][:25] == '/var/cache/c2padmin/isos/'):
						record = cache.cache.get_iso_record(file_to_copy[0])
						if(record == None):
							data = {'uuid': src_data['uuid'], 'target': file_to_copy[1]}
							eject = eject_media(data)
							if(not eject):
								raise Exception('ISO not founda and couldn\'t be ejected')
								
						else:	
							data = {}
							data['dst_nod_ip'] = dst_data['dst_nod_ip']
							data['src_addr'] = src_data['src_nod_ip']
							data['url'] = record[0]
							data['size'] = record[1]
							data['last_modified'] = record[2]
	 						data['path'] = record[3]
		
							try: 
								logger.info('Copying ISO {} to destination server'.format(data['path']))
								nc = network.remote_fcall("util.copy_iso", data)
								if(nc != True):
									data = {'uuid': src_data['uuid'], 'target': file_to_copy[1]}
									eject = eject_media(data)
									if(not eject):
										raise Exception('Couldn\'t copy or eject iso %s', (file_to_copy[0],))
								
							except: 
								logger.error('Couldn\'t copy or eject iso %s', (file_to_copy[0],))
								raise Exception('Couldn\'t copy or eject iso %s', (file_to_copy[0],))
						
					else:
						data = {}
						data['dst_nod_ip'] = dst_data['dst_nod_ip']
						data['src_addr'] = src_data['src_nod_ip']
						data['src_file'] = file_to_copy[0]
						data['dst_file'] = file_to_copy[0]
						
						try:
							logger.info('Copying file {} to destination server'.format(data['src_file']))
							nc = network.remote_fcall("util.copy_file", data)
							if(nc != True):
								data = {'uuid': src_data['uuid'], 'target': file_to_copy[1]}
								eject = eject_media(data)
								if(not eject):
									raise Exception('Couldn\'t copy or eject file %s', (file_to_copy[0],))
				
						except:
							logger.error('Couldn\'t copy or eject file %s', (file_to_copy[0],))
							raise Exception('Couldn\'t copy or eject file %s', (file_to_copy[0],))
					
				
				if(not check_node_compatibility(dst_data['uuid'])):
					raise Exception('HW compatibility error')
					
				migrate_flags = libvirt.VIR_MIGRATE_LIVE | libvirt.VIR_MIGRATE_PEER2PEER | libvirt.VIR_MIGRATE_PERSIST_DEST | libvirt.VIR_MIGRATE_UNDEFINE_SOURCE | libvirt.VIR_MIGRATE_NON_SHARED_DISK | libvirt.VIR_MIGRATE_UNSAFE
				target_uri = 'qemu+ssh://' + dst_data['dst_nod_ip'] + '/system'
				try:
					src_conn = libvirt.open(None)
					
				except:
					raise Exception('Couldn\'t connect to local libvirt')
				
				try:	
					dst_conn = libvirt.open(target_uri)
					
				except:
					raise Exception('Couldn\'t connect to destination libvirt')
					
				try:
					dom = src_conn.lookupByName(src_data['name'])
					
				except:
					raise Exception('Domain not found')
				
				src_conn.close()
				try: 
					nc = network.remote_fcall("virt.guest.prepare_migration_dest", dst_data)
					if(nc != True):
						raise Exception('Couldn\'t prepare migration destination')
						
				except: 
					logger.error('Couldn\'t prepare migration destination')
					raise Exception('Couldn\'t prepare migration destination' % (src_bytes, dio_size))
				
				set_autostart_server({'uuid': src_data['uuid'],'autostart':False})
				try:
					migrate_res = [None, None]
					migrate_th = threading.Thread(target=live_migrate, args=(dom, migrate_res, dst_conn, migrate_flags, src_data['name'], target_uri, 2000))
					migrate_th.start()
					
				except:
					dst_conn.close()
					raise Exception('Unable to migrate domain!!!\n%s' % (traceback.format_exc(),))
				
				migrate_th.join(1)
				status_updated = time.time()
				status_last = 0
				status = status_last
				suspended = False
				frozen_migration = False
				
				while migrate_th.isAlive():
					new_status = query_block_jobs(src_data['name'])
					
					if(new_status != None and new_status != 0):
						status = new_status
						
					if(progress != None):
						progress.set(status)
						
					if(status_last != status):
						status_updated = time.time()
						status_last = status
						
					if((new_status != None and new_status != 0 and new_status < 0.99) and (time.time() - status_updated > 60*5)):
						frozen_migration = True
						dom.abortJob()
						break;
						
					if((status >= 0.99) and (time.time() - status_updated > 60*60) and not suspended):
						suspended = True
						dom.suspend()
						
					migrate_th.join(1)
					
				if frozen_migration:
					dst_conn.close()
					try: 
						nc = network.remote_fcall("virt.guest.undefine_server", dst_data)
						if(nc != True):
							raise Exception('Couldn\'t undefine failed server')
							
					except: 
						logger.error('Couldn\'t undefine failed server')
					
					if(src_data['autostart']):
						set_autostart_server({'uuid': src_data['uuid'],'autostart': True})
							
					raise Exception('Progress status froze at %s, vps was restarted.' % (status,))
				
				dst_conn.close()
				if(not migrate_res[0]):
					if(src_data['autostart']):
						set_autostart_server({'uuid': src_data['uuid'],'autostart': True})
						
					raise Exception('Unable to migrate domain!!!\n%s' % (migrate_res[1],))
					
				
				conn = libvirt.open(None)
				try:
					time.sleep(5)
					dom = conn.lookupByName(src_data['name'])
					if(src_data['autostart']):
						set_autostart_server({'uuid': src_data['uuid'],'autostart': True})
						
					raise Exception('Live migration failed (domain is still active on source).')
					
				except:
					pass
				
				if(dst_data['autostart']):
					nc = network.remote_fcall("virt.guest.set_autostart_server", dst_data)
					
				try: 
					volume.remove_volume(src_data['lv_name'])
				
				except: 
					logger.error('Couldn\'t remove source volume')
					
	
	return True
	
def check_node_compatibility(node_uuid):
	return True

def query_block_jobs(name):
	qmp_path = "/var/lib/libvirt/qemu/%s.qmpcustom" % (name,)
	if not os.path.exists(qmp_path):
		return None
		
	try:
		s = socket.socket(socket.AF_UNIX)
		s.connect(qmp_path)
		d = s.recv(4096)
		s.send('{ "execute": "qmp_capabilities" }')
		d = s.recv(4096)
		s.send('{ "execute":"query-block-jobs" }')
		d = s.recv(4096)
		s.close()
		j = json.loads(d)
		if not j.has_key('return'):
			return None
			
		total_size = 0
		total_completed = 0
		for dev in j['return']:
			total_size += dev['len']
			total_completed += dev['offset']
			
		if total_size == 0:
			return 0
			
		else:
			return (float(total_completed)/float(total_size))*0.99
			
	except:
		return None
	
def live_migrate(dom, result, *args, **kwargs):
	try:
		dom.migrate(*args,**kwargs)
		
	except libvirt.libvirtError, e:
		result[0] = False
		result[1] = e.get_error_message()
		return
		
	except:
		result[0] = False
		result[1] = "Unknown error"
		return
		
	result[0] = True
	return
	
def clonemigrate_server(data,progress):
	"""docstring for clone_server"""
	# migrace prenasi vps, pri klonovani je mozne zaroven menit fyzicke parametry vps
	# klonovani je mozne v ramci stejneho nodu nebo na zcela jiny a pokud zdrojove vps bezi, tak je mozne pouzit snapshot
	# migrace je mozna pouze na jiny nod a snaphost neni povolen
	# jestli jde o klonovani nebo migraci se urcuje porovnanim uuid zdrojoveho a ciloveho vps
	# zdrojove vps vypne (pokud predtim bezelo), zalozi cilove vps podle prichoziho vhost_data, skopiruje obsah disku
	# po klonovani (nebo pri snapshote v prubehu) zapne zdrojove vps (pokud predtim bezelo), cilove vps zapne/vypne podle parametru dst_vps_start jinak nechava vypnute
	# po migraci zapne zdrojove vps (pokud predtim bezelo)
	# v pripade klonovani na jiny nod nebo migraci se na zdroji otevre disk a server socket a spusti se vlakno pro lv2socket
	# ve druhem vlaknu se hakom pres funkci remote_fcall spusti na vzdalenem zdroji funkce socket2lv
	# socket2lv vraci int zapsanych bytu ktery musi byt rovny velikosti zdrojoveho disku, jinak se vyhlasi chyba
	# pokud neco neprojde/selze melo by skoncit na chybe nebo timeoute a v takovem pripade se pokusi o uklid
	# funkce nastavuje progress bar (pro command zdroje)
	# vstup json, povinne src_vps_uuid, dst_nod_uuid, dst_vps_uuid/dst_vhost_data (stejny parameter jako pro define_server)
	# nepovinne blockSize (default 4 MiB) - nastavuje velikost bloku ktery zdroj posila, socket_timeout (default 60 s) - timeout na sitovy prenos, snap_size v GiB (default None) - velikost snapshotu, timeout - timeout pro vypnuti zdroje, autostart - nastavi autostart, dst_vps_start - nastavi zapnuti ciloveho vps
	# default se nastavi take pokud budou hodnoty nevalidni
	
	src_vps_uuid = str(data['src_vps_uuid'])
	dst_nod_uuid = str(data['dst_nod_uuid'])
	
	try: data['blocksize'] = int(data['blocksize'])
	except: data['blocksize'] = 4*1024*1024
	try: data['socket_timeout'] = int(data['socket_timeout'])
	except: data['socket_timeout'] = 60
	try: data['timeout'] = int(data['timeout'])
	except: data['timeout'] = 90
	try: snap_size = int(data['snap_size'])
	except: snap_size = None
	
	vesmir = network.get_universe()

	src_data = {}
	src_data['uuid'] = str(data['src_vps_uuid'])
	src_data['src_nod_uuid'] = c2padmin.config.node_config['uuid']
	src_data['src_nod_ip'] = c2padmin.config.node_config['unicast_ip']
	src_data['dst_nod_ip'] = vesmir[dst_nod_uuid]['unicast_ip']
	src_data['socket_timeout'] = data['socket_timeout']
	src_data['blocksize'] = data['blocksize']
	src_data['lv_name'] = get_name_from_uuid(src_vps_uuid)
	src_data['name'] = src_data['lv_name']
	src_data['timeout'] = data['timeout']
	try: src_data['autostart'] = bool(data['autostart'])
	except: src_data['autostart'] = get_autostart_server(src_data)

	dst_data = {}
	try:
		dst_data['uuid'] = str(data['dst_vps_uuid'])
		dst_data['lv_name'] = src_data['lv_name']
		dst_data['name'] = src_data['name']
		dst_data['disk_space'] = volume.get_lv(src_data['lv_name'],units='B')[1]
		dst_data['disk_units'] = 'B'
		conn = libvirt.open(None)
		dom = conn.lookupByUUIDString(src_data['uuid'])
		xml = parseString(dom.XMLDesc(libvirt.VIR_DOMAIN_XML_SECURE | libvirt.VIR_DOMAIN_XML_INACTIVE))
		dst_data['libvirt_xml'] = xml.toxml()
		conn.close()
	except:
		try:
			dst_data = data['dst_vhost_data']
			dst_data['lv_name'] = str(data['dst_vhost_data']['name'])
		except:
			raise

	dst_data['socket_timeout'] = data['socket_timeout']
	dst_data['dst_nod_uuid'] = str(data['dst_nod_uuid'])
	dst_data['dst_nod_ip'] = vesmir[dst_nod_uuid]['unicast_ip']
	dst_data['src_nod_ip'] = c2padmin.config.node_config['unicast_ip']
	try: dst_data['autostart'] = bool(data['dst_vhost_data']['autostart'])
	except: dst_data['autostart'] = src_data['autostart']
	try: dst_vps_start = bool(data['dst_vps_start'])
	except: dst_vps_start = False
	
	conn = libvirt.open()
	dom = conn.lookupByUUIDString(src_vps_uuid)
	if dom.info()[0] == libvirt.VIR_DOMAIN_RUNNING: src_vps_start = True
	else: src_vps_start = False
	conn.close()
	
	if src_data['uuid'] == dst_data['uuid']: 
		if src_data['src_nod_uuid'] == dst_data['dst_nod_uuid']:
			raise Exception('Pointless local migration. Terminated.')
		snap_size = None
	
	try: turnoff_server(src_data)
	except: raise 
	if src_vps_start and snap_size != None:
		try: 
			src_data['lv_name'] = volume.create_snapshot(src_data['lv_name'],size=snap_size)
		except: 
			if src_vps_start: 
					try: turnon_server(src_data)
					except: pass
			raise
	
	if src_data['src_nod_uuid'] == dst_data['dst_nod_uuid']:
		try: 
			define_server(dst_data)
		except Exception,e:
			try: undefine_server(dst_data)
			except: pass
			if src_vps_start: 
				if snap_size != None:
					try: volume.remove_volume(src_data['lv_name'])
					except: pass
				try: turnon_server(src_data)
				except: pass
			raise Exception(str(e))	
		if src_vps_start and snap_size != None:
			try: turnon_server(src_data)
			except: pass
		try:
			src_dio = open_dio(src_data['lv_name'])
			dst_dio = open_dio(dst_data['lv_name'], mode=os.O_WRONLY)
			lv_size = src_dio.getsize()
			for i in range(lv_size//src_data['blocksize']):
				dst_dio.write(src_dio.read(src_data['blocksize']))
				progress.set(float(i*src_data['blocksize'])/float(lv_size))
			if lv_size%src_data['blocksize'] > 0:
				dst_dio.write(src_dio.read(lv_size%src_data['blocksize']))
			src_dio.close()
			dst_dio.close()
		except: 
			try: src_dio.close()
			except: pass
			try: dst_dio.close()
			except:	pass
			try: undefine_server(dst_data)
			except: pass
			if src_vps_start: 
				if snap_size != None:
					try: volume.remove_volume(src_data['lv_name'])
					except: pass
				try: turnon_server(src_data)
				except: pass
			raise	
		if src_vps_start: 
			if snap_size != None:
				try: volume.remove_volume(src_data['lv_name'])
				except: raise
			try: turnon_server(src_data)
			except: raise
		set_autostart_server(dst_data)
		if dst_vps_start: turnon_server(dst_data)
	else:
		try:
			nc = network.remote_fcall("virt.guest.define_server",dst_data)
		except Exception,e:
			try: nc = network.remote_fcall("virt.guest.undefine_server",dst_data)
			except: pass
			if src_vps_start: 
				if snap_size != None:
					try: volume.remove_volume(src_data['lv_name'])
					except: pass
				try: turnon_server(src_data)
				except: pass
			raise Exception(str(e))
		if src_vps_start and snap_size != None:
			try: turnon_server(src_data)
			except: pass
		try:
			dio = open_dio(src_data['lv_name'])
			lv_size = dio.getsize()
			s = open_server_socket(src_data)
			port = s.getsockname()[1]
		except: 
			try: dio.close()
			except: pass
			try: close_socket(s)
			except: pass
			try: nc = network.remote_fcall("virt.guest.undefine_server",dst_data)
			except: pass
			if src_vps_start: 
				if snap_size != None:
					try: volume.remove_volume(src_data['lv_name'])
					except: pass
				try: turnon_server(src_data)
				except: pass
			raise

		transferred_bytes = TRANSFERRED_BYTES()
		src_data["dio"] = dio
		src_data["socket"] = s
		dst_data["port"] = port
		
		src_th = threadwrap(lv2socket, [src_data], transferred_bytes = transferred_bytes)
		dst_th = threadwrap(network.remote_fcall,["virt.guest.socket2lv",dst_data],transferred_bytes=None)
		prev_transferred_bytes = 0
		while src_th.isAlive() or dst_th.isAlive():
			if transferred_bytes > 0 and int(transferred_bytes) != prev_transferred_bytes:
				prev_transferred_bytes = int(transferred_bytes)
				progress.set(transferred_bytes/float(lv_size))
		try: dio.close()
		except: pass
		try: close_socket(s)
		except: pass
		try: 
			dst_bytes = int(dst_th.result)
			src_bytes = int(src_th.result)
		except: 
			try: nc = network.remote_fcall("virt.guest.undefine_server",dst_data)
			except: pass
			if src_vps_start: 
				if snap_size != None:
					try: volume.remove_volume(src_data['lv_name'])
					except: pass
				try: turnon_server(src_data)
				except: pass
			raise Exception("%s\n%s" % (dst_th.result,src_th.result))
		if dst_bytes != src_bytes:
			try: nc = network.remote_fcall("virt.guest.undefine_server",dst_data)
			except: pass
			if src_vps_start: 
				if snap_size != None:
					try: volume.remove_volume(src_data['lv_name'])
					except: pass
				try: turnon_server(src_data)
				except: pass
			raise Exception("Data transfer failed %s/%s" % (src_bytes,dio_size))

		if src_data['uuid'] == dst_data['uuid']:
			try: undefine_server(src_data)
			except: raise
			if src_vps_start: 
				try: nc = network.remote_fcall("virt.guest.turnon_server",dst_data)
				except: raise			
		else:
			if src_vps_start: 
				if snap_size != None:
					try: volume.remove_volume(src_data['lv_name'])
					except: raise
				try: turnon_server(src_data)
				except: raise
		nc = network.remote_fcall("virt.guest.set_autostart_server",dst_data)
		if dst_vps_start: nc = network.remote_fcall("virt.guest.turnon_server",dst_data)

def xml_rpc_request(vps_uuid, request_string, timeout, progress = None):
	conn = libvirt.open()
	dom = conn.lookupByUUIDString(vps_uuid)
	if(dom == None):
		conn.close()
		return [False, 'Invalid VPS UUID: %s' % (vps_uuid,)]
		
	if(dom.info()[0] != 1):
		conn.close()
		return [False, 'VPS not running']
	
	xml = parseString(dom.XMLDesc())
	conn.close()
	
	vserver_name = str(xml.getElementsByTagName('name')[0].childNodes[0].data)
	vport_path = '/var/lib/libvirt/qemu/%s.vport' % (vserver_name,)
	
	if(not os.path.exists(vport_path)):
		raise Exception('Invalid VPS: %s, vport path does not exist' % (vserver_name,))
		
	for channel in xml.getElementsByTagName('devices')[0].getElementsByTagName('channel'):
		if(len(channel.getElementsByTagName('source')) and channel.getElementsByTagName('source')[0].getAttribute('path') == vport_path):
			if channel.getElementsByTagName('target')[0].getAttribute('state') == 'disconnected':
				return [False, 'Remote endpoint not connected']
		
	if(vserver_name not in c2padmin.config.node_system_locks['xmlrpc']):
		c2padmin.config.node_system_locks['xmlrpc'][vserver_name] = threading.Lock()
		
	with c2padmin.config.node_system_locks['xmlrpc'][vserver_name]:
		# clean socket
		sock = socket.socket(socket.AF_UNIX, socket.SOCK_STREAM)
		sock.settimeout(0.5)
		sock.connect(vport_path)
		while True:
			try:
				sock.recv(4096)
				
			except:
				break	
		
		sock.close()
		
		data = xmlrpclib.loads(request_string)
		fce = data[1]
		data = data[0]
		if(len(data) == 2):
			data += (None,timeout)

		elif(len(data) == 3):
			data += (timeout, )

		else:
			raise Exception('Bad request_string' % (vps,))

		request_string = xmlrpclib.dumps(data, fce, allow_none = True)
	
		conn = c2padmin.util.UHTTPConnection(vport_path, timeout = timeout)
		conn.request('POST', '/', request_string)
		res = conn.getresponse()
	
		if res.status == 200:
			ret = [True,res.read()]
		else:
			ret = [False,res.read()]
	
		conn.close()
	
	return ret
	
def resize_partition(pv_dev, progress = None):
	if('resize_partition' not in c2padmin.config.node_system_locks):
		c2padmin.config.node_system_locks['resize_partition'] = threading.Lock()
		
	with c2padmin.config.node_system_locks['resize_partition']:
		relevant_dev = re.match('^\/dev\/HostVG\/(virtual\_[0-9]+)$', pv_dev)
		if(relevant_dev == None):
			raise Exception('Invalid volume path')
		
		vserver_name = relevant_dev.group(1)
		
		devnull = open('/dev/null','w')
		
		partition_table = subprocess.check_output(['fdisk', '-l', pv_dev], stderr=devnull).strip().split('\n')
		partition_table = map(lambda x: {'id': x.group(1), 'start': x.group(2), 'size': x.group(3), 'type': x.group(4)}, filter(lambda x: x != None, map(lambda x: re.match('^{}p([0-9]+)\s+\*?\s+([0-9]+)\s+[0-9]+\s+([0-9]+)\s+([0-9a-f]+)'.format(pv_dev.replace('/', '\/')), x), partition_table)))
		if(len(partition_table) != 2):
			raise Exception('invalid disk partitioning')
		
		resizing_partition = filter(lambda x: x['id'] == '2', partition_table)
		if(len(resizing_partition) != 1 or resizing_partition[0]['type'] != '8e'):
			raise Exception('invalid disk partitioning')
		
		resizing_partition = resizing_partition[0]
		
		fdisk = subprocess.Popen(['fdisk', pv_dev], stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
		fdisk.communicate('d\n2\nn\np\n2\n' + resizing_partition['start'] + '\n\nt\n2\n' + resizing_partition['type'] + '\nw\n')
		
		res = subprocess.call(['kpartx', '-a', pv_dev])
		if(res != 0):
			raise Exception('partition mapping failed')
	
		dm_device = '/dev/mapper/HostVG-{}p2'.format(vserver_name)
		time.sleep(2)
		res = subprocess.call(['vgchange', '-ay', 'VirtVG'])
		if(res != 0):
			raise Exception('activate LV failed')
		
		
		
		res = subprocess.call(['pvresize', dm_device])
		if(res != 0):
			raise Exception('PV resize failed')
		
		res = subprocess.call(['lvresize', '-l+100%FREE', '/dev/VirtVG/root'])
		if(res != 0):
			raise Exception('LV resize failed')
		
		res = subprocess.call(['fsck', '-fy', '/dev/VirtVG/root'])
		
		try:
			fs_type = subprocess.check_output(['blkid', '/dev/mapper/VirtVG-root'])
			fs_type = re.search("TYPE=\"(.*)\"", fs_type).group(1)
		
		except:
			fs_type = None	
		
		if(fs_type == 'xfs'):
			chroot = '/tmp/virtroottemp'
			os.makedirs(chroot)
			res = subprocess.call(['mount', '/dev/VirtVG/root', chroot])
			if(res != 0):
				raise Exception('Mount VPS root failed')
				
			res = subprocess.call(['xfs_growfs', '/dev/VirtVG/root'])
			if(res != 0):
				raise Exception('xfs_growfs failed')
				
			res = subprocess.call(['umount', chroot])
			if(res != 0):
				raise Exception('umount failed')
			
			os.rmdir(chroot)
		
		else:
			raise Exception('unknown filesystem')
						
		
		res = subprocess.call(['vgchange', '-an', 'VirtVG'])
		if(res != 0):
			raise Exception('deactivationg LV failed')
			
		res = subprocess.call(['kpartx', '-d', pv_dev])
		if(res != 0):
			raise Exception('partition unmapping failed')
			
		return True

