import sys, os, time, libvirt, re, datetime

def qemu(args=sys.argv, stdin=sys.stdin, stdout=sys.stdout,stderr=sys.stderr):
	"""docstring for qemu"""
	global logfile
	# pre scripts
	if os.path.isdir('/etc/libvirt/hooks/qemu.pre.d'):
		pass
	
	# our magic
	if len(args) < 5:
		# divny pocet argumentu, radeji koncime
		return 0
	
	manage_interface = 'brup'
	args = sys.argv
	logfile = '/var/log/libvirt-hooks-qemu.log'
	if os.path.exists(logfile):
		log = open(logfile,'a')
	else:
		log = open(logfile,'w')
	log.write(datetime.datetime.now().isoformat()+': '+str(args)+'\n')
	log.close()

	interfaces = []
	ip = None
	xml = get_xml(args[1])
	if xml != None:
		ip = get_manage_ip(xml)
		interfaces = get_interfaces(xml)
	if args[2] == 'migrate' and args[3] == 'begin':
		xml = get_xml(args[1], True)
		if xml != None:
			ip = get_manage_ip(xml)
			interfaces = get_interfaces(xml)
		for interface in interfaces:
			if not check_interface(interface):
				raise Exception('Unable to bring up interface. See log file: '+interface)
		if ip != None:
			os.system('ip ad add %s/32 dev lo >>%s 2>&1' % (ip,logfile))
	elif args[2] == 'prepare' and args[3] == 'begin':
		for interface in interfaces:
			if not check_interface(interface):
				raise Exception('Unable to bring up interface. See log file: '+interface)
	elif args[2] == 'started' and args[3] == 'begin':
		if ip != None:
			if not os.path.exists('/dev/shm/vh-manage-interfaces'):
				os.mkdir('/dev/shm/vh-manage-interfaces')
			open('/dev/shm/vh-manage-interfaces/%s' % (ip,), 'w').close()
			os.system('arping -c3 -U -I %s %s >>%s 2>&1' % (manage_interface,ip,logfile))
	elif args[2] == 'start' and args[3] == 'begin':
		if ip != None:
			os.system('ip ad sh dev %s | grep %s/24 >/dev/null && ip ad del %s/24 dev %s >>%s 2>&1; ip ad add %s/32 dev lo >>%s 2>&1' % (manage_interface, ip, ip, manage_interface, logfile, ip, logfile) )
		# os.system('python /root/server/virtual/memcache-status.py %s start >>%s 2>&1 </dev/null &' % (args[1],logfile))
	elif args[2] == 'release' and args[3] == 'end':
		if ip != None:
			if os.path.exists('/dev/shm/vh-manage-interfaces/%s' % (ip,)):
				os.unlink('/dev/shm/vh-manage-interfaces/%s' % (ip,))
			os.system('ip ad del %s/32 dev lo >>%s 2>&1' % (ip,logfile))
		# os.system('python /root/server/virtual/memcache-status.py %s stop >>%s 2>&1 </dev/null &' % (args[1],logfile))
		libvirt_status = os.system('service libvirt-guests status >/dev/null 2>&1 </dev/null')
		libvirt_status = libvirt_status>>8
		# autostart z xml metadata:
		# xml.getElementsByTagName('metadata')[0].getElementsByTagName('c2pauto:metadata')[0].getElementsByTagName('autostart')[0].childNodes[0].data
		if (libvirt_status==0 and os.path.exists('/etc/libvirt/qemu/autostart/%s.xml' % args[1])):
			os.system('virsh start %s >>%s 2>&1 </dev/null &' % (args[1], logfile))
	
	# post scripts
	if os.path.isdir('/etc/libvirt/hooks/qemu.post.d'):
		pass
		
	return 0

def check_interface(interface):
	global logfile
	backbone_iface = 'brup'
	if os.system('ip link sh dev %s >/dev/null 2>&1' % (interface,)) == 0:
		return True
	mymatch = re.match('^bx([0-9a-f]{6})(\.[0-9]{1,4})?$',interface)
	if mymatch != None:
		# VxLAN
		vx_id = mymatch.group(1)
		if mymatch.group(2) != None:
			vl_id = int(mymatch.group(2)[1:])
		else:
			vl_id = 1
		if os.system('ip link sh dev vx%s >/dev/null 2>&1' % (vx_id,)) != 0:
			retcode = os.system('''ip link add vx%s mtu 1500 type vxlan id 0x%s group 239.74.234.4 dev %s dstport 4789 >>%s 2>&1 && \
			ip link set up dev vx%s >>%s 2>&1''' % (vx_id,vx_id,backbone_iface, logfile, vx_id, logfile))
			if retcode != 0:
				return False
		if vl_id > 1:
			if os.system('ip link sh dev vx%s.%d >/dev/null 2>&1' % (vx_id,vl_id)) != 0:
				retcode = os.system('''ip link add link vx%s vx%s.%d mtu 1500 type vlan proto 802.1Q id %d >>%s 2>&1 && \
					ip link set up dev vx%s.%d >>%s 2>&1
				''' % (vx_id,vx_id,vl_id,vl_id,logfile,vx_id,vl_id,logfile))
				if retcode != 0:
					return False
			retcode = os.system('''brctl addbr bx%s.%d >>%s 2>&1 && \
				ip link set up dev bx%s.%d >>%s 2>&1 && \
				brctl addif bx%s.%d vx%s.%d >>%s 2>&1 && \
				brctl stp bx%s.%d on >>%s 2>&1
			''' % (vx_id,vl_id,logfile,vx_id,vl_id,logfile,vx_id,vl_id,vx_id,vl_id,logfile,vx_id,vl_id,logfile))
			if retcode != 0:
				return False
		else:
			if os.system('ip link sh dev bx%s >/dev/null 2>&1' % (vx_id,)) != 0:
				retcode = os.system('''brctl addbr bx%s >>%s 2>&1 && \
					ip link set up dev bx%s >>%s 2>&1 && \
					brctl addif bx%s vx%s >>%s 2>&1 && \
					brctl stp bx%s on >>%s 2>&1
				''' % (vx_id,logfile,vx_id,logfile,vx_id,vx_id,logfile,vx_id,logfile))
				if retcode != 0:
					return False
		return True
	mymatch = re.match('^vbr2\.([0-9]+)$', interface)
	if mymatch != None:
		# QinQ
		vlan_id = int(mymatch.group(1))
		retcode = os.system('''ip link add link bond0.2 bond0.2.%d mtu 1500 type vlan proto 802.1Q id %d >>%s 2>&1 && \
			ip link set up dev bond0.2.%d >>%s 2>&1 && \
			brctl addbr vbr2.%d >>%s 2>&1 && \
			brctl addif vbr2.%d bond0.2.%d >>%s 2>&1 && \
			ip link set up dev vbr2.%d >>%s 2>&1''' % (vlan_id, vlan_id, logfile, vlan_id, logfile, vlan_id, logfile, vlan_id, vlan_id, logfile, vlan_id, logfile))
		if retcode == 0:
			return True
		else:
			return False
	mymatch = re.match('^vbr([0-9]+)$', interface)
	if mymatch != None:
		vlan_id = int(mymatch.group(1))
		retcode = os.system('sh /root/server/tools/add-vlan.sh %d >>%s 2>&1' % (vlan_id, logfile))
		if retcode == 0:
			return True
		else:
			return False
	os.system('echo Unimplemented interface type %s >> %s' % (interface,logfile))
	return False

def get_xml(vps, stdin = False, stdinfd=sys.stdin):
	try:
		from xml.dom.minidom import parseString
		if stdin:
			fh = stdinfd
		else:
			fh = open('/etc/libvirt/qemu/%s.xml' % vps)
		config = ''
		d = fh.read()
		while d != '':
			config += d
			d = fh.read()
		fh.close()
		xml = parseString(config)
		return xml
	except:
		return None

def get_manage_ip(xml):
	try:
		ip = xml.getElementsByTagName('devices')[0].getElementsByTagName('graphics')[0].getAttribute('listen')
		if ip == '0.0.0.0' or ip == "":
			return None
		else:
			return ip
	except:
		return None

def get_interfaces(xml):
	try:
		interfaces = []
		for elem in xml.getElementsByTagName('devices')[0].getElementsByTagName('interface'):
			if elem.getAttribute('type') == 'bridge':
				interfaces.append(elem.getElementsByTagName('source')[0].getAttribute('bridge'))
		return interfaces
	except:
		return []

def get_autostart(xml):
	try:
		ret = xml.getElementsByTagName('metadata')[0].getElementsByTagName('c2pauto:metadata')[0].getElementsByTagName('autostart')[0].childNodes[0].data
	except:
		ret = 0
	return ret
