#include <Python.h>

static PyObject *
readinto(PyObject *self, PyObject *args)
{
    Py_buffer pbuf;
    int fd;
    Py_ssize_t size;

    if (!PyArg_ParseTuple(args, "is*:readinto", &fd, &pbuf))
        return NULL;
    Py_BEGIN_ALLOW_THREADS
    size = read(fd, pbuf.buf, (size_t)pbuf.len);
    Py_END_ALLOW_THREADS
        PyBuffer_Release(&pbuf);
    if (size < 0)
        return PyErr_SetFromErrno(PyExc_OSError);;
    return PyInt_FromSsize_t(size);
}

static PyMethodDef dioutilc_methods[] = {
    {"readinto",             readinto,      METH_VARARGS,
     "Read file hangler into pre-existing buffer"},
    {NULL,              NULL}           /* sentinel */
};

void
initdioutilc(void)
{
    PyImport_AddModule("dioutilc");
    Py_InitModule("dioutilc", dioutilc_methods);
}
